<template>
    <div id="app">

        <button type="button" class="btn btn-info padding" data-toggle="modal" data-target="#myModal"> <i class="fa fa-upload margin-right-15"></i> Upload Image</button>
        <div id="myModal" class="modal fade" role="dialog">
            <div class="modal-dialog">

                <!-- Modal content-->
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal">&times;</button>
                        <h4 class="modal-title"><i class="fa fa-upload"></i> Upload Picture</h4>
                    </div>
                    <div class="modal-body">
                        <flash-message transitionIn="animated swing" class="myCustomClass"></flash-message>
                        <div class="button-wrapper">
                        <span class="button" >
                            <input type="file" @change="onFileChanged" accept="image/*">
                            
                        </span>
                        </div>
                        <cropper
                                v-if="notCropped"
                                classname="cropper"
                                :src="image"
                                :stencilProps="{
                                  aspectRatio: 1/1
                                }"
                                ref="cropper"
                                stencilComponent="circle-stencil"
                        ></cropper>
                        <div class="text-center">
                            <img v-if="crop" v-bind:src="image" class="circle-image-full"/>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button v-show="notCropped" @click="cropped()" class="btn btn-default">
                            Crop
                        </button>
                        <button v-if="crop" @click="clear()" class="btn btn-default pull-left">Clear</button>
                        <button v-if="crop" @click="postImage()" class="btn btn-primary">Upload</button>
                    </div>
                </div>

            </div>
        </div>

    </div>
</template>

<script>
    import { Cropper, ResizeEvent  } from 'vue-advanced-cropper'
    
    export default {
        components: { Cropper, ResizeEvent },
        props:[],
        name: "imageUpload",
        data(){
            return {
                image: null,
                crop:false,
                notCropped:true,
                coordinates:null,
            }
        },
        methods: {
            onFileChanged(event) {
                // Reference to the DOM input element
                var input = event.target;

                // Ensure that you have a file before attempting to read it
                if (input.files && input.files[0]) {
                    // create a new FileReader to read this image and convert to base64 format
                    var reader = new FileReader();
                    // Define a callback function to run, when FileReader finishes its job
                    reader.onload = (e) => {
                        // Note: arrow function used here, so that "this.imageData" refers to the imageData of Vue component
                        // Read image as base64 and set to imageData
                        this.image = e.target.result;
                    }
                    // Start the reader job - read file as a data url (base64 format)
                    reader.readAsDataURL(input.files[0]);
                }
            },
            clear(){
                this.image = null;
                this.crop = false;
                this.notCropped = true;
            },

            postImage(){
                axios.post('/dashboarduser/uploadProfileImage', {
                    body: {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
                        'image' : this.image,
                    }
                }).then(response => {
                    this.flash(response.data['message'], response.data['status'],{timeout: 3000});

                }).catch(e => {
                    this.flash('Server 500 error please try again', 'error',{timeout: 3000});
                    console.log(e);
                })

                this.$emit('update:avatar', this.image);
                var preview = document.getElementById('avatar_small');
                preview.src = this.image;
            },
            cropped(){
                const {coordinates, canvas} = this.$refs.cropper.getResult();
                this.coordinates = coordinates;
                // You able to do different manipulations at a canvas
                // but there we just get a cropped image
                this.$refs.cropper.setCoordinates({
                    width: coordinates.width,
                    height: coordinates.height,
                    left: coordinates.left,
                    top: coordinates.top
                });
                this.image = canvas.toDataURL();
                this.crop = true;
                this.notCropped = false;
            }
        },
    }
</script>

<style scoped>

</style>